/* Copyright (c) 2000-2001 ActiveState Tool Corporation.
   See the file LICENSE.txt for licensing information. */

var dialog;     // Quick access to document/form elements.
var gFindInst;   // nsIWebBrowserFind that we're going to use
var findService;

function initDialogObject()
{
    // get the find service, which stores global find state
    findService = Components.classes["@mozilla.org/find/find_service;1"]
                           .getService(Components.interfaces.nsIFindService);
    // Create dialog object and initialize.
    dialog = new Object;
    dialog.findKey         = document.getElementById("dialog.findKey");
    dialog.caseSensitive   = document.getElementById("dialog.caseSensitive");
    dialog.wrap            = document.getElementById("dialog.wrap");
    dialog.searchBackwards = document.getElementById("dialog.searchBackwards");
    dialog.find            = document.getElementById("ok");
  
    // Move dialog to center, if it not been shown before
    var windowElement = document.getElementById("dialog");
    if (!windowElement.hasAttribute("screenX") || !windowElement.hasAttribute("screenY"))
    {
        window.sizeToContent();
        dialog.moveToAlertPosition();
    }
}

function fillDialog()
{
    // Set initial dialog field contents.
    dialog.findKey.value           = findService.searchString;
    dialog.caseSensitive.checked   = findService.matchCase;
    dialog.wrap.checked            = findService.wrapFind;
    dialog.searchBackwards.checked = findService.findBackwards;
}

function saveFindData()
{
    // Set data attributes per user input.
    findService.searchString  = dialog.findKey.value;
    findService.matchCase     = dialog.caseSensitive.checked;
    findService.wrapFind      = dialog.wrap.checked;
    findService.findBackwards = dialog.searchBackwards.checked;
}

var log = getLoggingMgr().getLogger("dialogs.yesNo");

function onLoad()
{
    try {
        trace_onload();
        initDialogObject();
        // Change "OK" to "Find".
        var d = document.getElementById("dialog");
        var findButton = d.getButton("accept");
        findButton.setAttribute('label', 'Find Next');
        findButton.setAttribute('accesskey', 'F');
        dialog.find = document.getElementById('fBLT');
        dialog.find_label = document.getElementById("fBLT").getAttribute("label");
      
        // get the find instance
        gFindInst = window.arguments[0];
      
        fillDialog();
        doEnabling();
      
        if (dialog.findKey.value)
            dialog.findKey.select();
        else
            dialog.findKey.focus();
    } catch (e) {
        log.exception(e);
    }
}

function onUnload()
{
    window.opener.findDialog = 0;
}

function onOK()
{
    try {
        // Transfer dialog contents to the find service.
        saveFindData();
      
        // set up the find instance
        gFindInst.searchString  = dialog.findKey.value;
        gFindInst.matchCase     = dialog.caseSensitive.checked;
        gFindInst.wrapFind      = dialog.wrap.checked;
        gFindInst.findBackwards = dialog.searchBackwards.checked;
        
        // Search.
        var result = gFindInst.findNext();
        if (!result) {
            alert("The text you entered was not found.");
            return false;
        }
    } catch (e) {
        log.exception(e);
    }
    return false;
}

function onCancel()
{
  // Close the window.
  return true;
}

function doEnabling()
{
  dialog.find.disabled = !dialog.findKey.value;
}
