/* Copyright (c) 2000-2003 ActiveState Corporation.
   See the file LICENSE.txt for licensing information. */


//Arguments to window.arguments[0] are:
//    Required:
//        item: the item being edited
//        task: 'new' or 'edit'
//        type: the type of the part ('URL', 'template', etc...)
//        src:  the chrome of the image to be used in the dialog
//    Optional:
//        valueToTextConverter: function that takes the part's 'value' 
//                              and converts it to the text which is
//                              stuffed in the 'value' textbox.
//    
//        textToValueConverter: function that takes the contents of the
//                              'value' textbox and converts it to what
//                              will be stuffed in the part's value.

var partname, partvalue, gOKButton, keybinding, gPart, gItem;
var shortcut_tab, part_tab, tabs, partnamelabel, gApplyButton;
var partViewManager;
var gPartType, gPartPrettyType;
var textToValueConverter = null;
var valueToTextConverter = null;


function onLoad() {
    try {
        trace_onload();
        var dialog = document.getElementById("dialog");
        gOKButton = dialog.getButton("accept");
        gApplyButton = dialog.getButton("extra1");
        gApplyButton.setAttribute('label', 'Apply');
        gApplyButton.setAttribute('accesskey', 'a');
    
        gItem = window.arguments[0].item;
        gPartType = window.arguments[0].type;
        gPartPrettyType = window.arguments[0].prettytype;
        if ('textToValueConverter' in window.arguments[0]) {
            textToValueConverter = window.arguments[0].textToValueConverter;
        }
        if ('valueToTextConverter' in window.arguments[0]) {
            valueToTextConverter = window.arguments[0].valueToTextConverter;
        }
        gPart = gItem.part;
        document.getElementById('partimg').setAttribute('src', window.arguments[0].imgsrc);
        document.getElementById('partimg2').setAttribute('src', window.arguments[0].imgsrc);
    
        if (window.arguments[0].task == 'new') {
            window.title = "Create New " + gPartPrettyType;
            gApplyButton.setAttribute('collapsed', 'true');
        } else {
            window.title =  gPartPrettyType + " Properties";
        }
    
        tabs = document.getElementById('tabs');
        shortcut_tab = document.getElementById('shortcut_tab');
        part_tab = document.getElementById('part_tab');
        partname = document.getElementById('partname');
        partname.value = gPart.getStringAttribute('name');
        partvalue = document.getElementById('partvalue');
        partnamelabel = document.getElementById('partnamelabel');
        tabs.selectedTab = part_tab; // we may want to change this sometimes.
        
        keybinding = document.getElementById('keybindings');
        keybinding.gKeybindingMgr = opener.gKeybindingMgr;
        keybinding.part = gPart;
    
        keybinding.commandParam = partname.value;
        var value = gPart.value;
        if (valueToTextConverter) {
            value = valueToTextConverter.call(this, value);
        }
        partvalue.value = value;
    
        keybinding.init();
        keybinding.updateCurrentKey();
        
        partname.focus();
        partname.select();
        updateOK();
    } catch (e) {
        log.error(e);
    }
};

function OK()  {
    if (_Apply()) {
        window.arguments[0].res = true;
    }
    window.close();
};

function Apply() {
    _Apply();
    gApplyButton.setAttribute('disabled', 'true');
    return false;
}

function _Apply()  {
    try {
        // The keybinding needs the commandparam to be set before the application would ever work.
        keybinding.commandParam = partname.value;
        var retval = keybinding.apply(); // This may return false if a keybinding is partially entered
        if (!retval) return retval;
    } catch (e) {
        opener.log.error(e);
        return false;
    }

    var value = partvalue.value;
    if (textToValueConverter) {
        value = textToValueConverter.call(this, value);
    }
    gPart.value = value;
    gItem.name = partname.value;
    opener.invalidateItem(gItem);
    gPart.setStringAttribute('name', partname.value);
    return true;
};

function updateOK() {
    if (partname.value == '' || partvalue.value== '') {
        gOKButton.setAttribute('disabled', 'true');
        gApplyButton.setAttribute('disabled', 'true');
    } else {
        if (gOKButton.hasAttribute('disabled')) { 
            gOKButton.removeAttribute('disabled');
        }
        if (gApplyButton.hasAttribute('disabled')) { 
            gApplyButton.removeAttribute('disabled');
        }
    }
}

function Cancel()  {
    window.arguments[0].res= false;
    window.close();
};
