/* Copyright (c) 2000-2001 ActiveState SRL. 
   See the file LICENSE.txt for licensing information. */

/* Web Services Setup Wizard - panel */

//---- globals

var _gPanelName = "wsSetup_ChooseModuleDir";



//---- internal support routines

function _UpdateModuleDir(moduleDir)
{
    // Persist.
    parent.wd_moduleDir = moduleDir;

    // Display the moduleDir selection.
    var moduleDirWidget = document.getElementById("module-dir");
    if (moduleDir == null) {
        moduleDirWidget.value = "";
    } else {
        moduleDirWidget.value = moduleDir;
    }

    // Pass to the setup service.
    var wsSetupSvc = parent.wsSetupSvcs[parent.wd_language];
    wsSetupSvc.SetModuleDir(moduleDir);
}



//---- Wizard Infrastructure interface routines

function validate()
{
    // Validate this page.
    // - Ask the setup service if the setup will work in this
    //   installation.
    var wsSetupSvc = parent.wsSetupSvcs[parent.wd_language];
    var problem = wsSetupSvc.ReasonCannotSetup_GivenModuleDir();
    if (problem) {
        alert(problem);
        return false;
    } else {
        return true;
    }
}


//---- interface for wsSetup_ChooseInstallation.xul

function OnLoad()
{
    // Give a nice header name for this pane.
    var headerWidget = parent.document.getElementById("header");
    headerWidget.setAttribute("title", "Choose Module Directory");
    headerWidget.setAttribute("description",
        "Select directory in which to install Web Service modules.");

    // Fill in the set of current include path directories for the
    // chosen PHP installation.
    var listWidget = document.getElementById("include-path-list");
    // - remove any existing items
    while (listWidget.hasChildNodes()) {
        listWidget.removeChild(listWidget.childNodes[0]);
    }
    // - get a list of include paths
    var phpInfoEx = Components.classes['@activestate.com/koPHPInfoEx;1'].
                    getService(Components.interfaces.koIPHPInfoEx);
    phpInfoEx.installationPath = parent.wd_installation;
    var includePath = new Array();
    includePath = phpInfoEx.GetIncludePathArray(new Object());
    // - populate the tree listing them
    if (includePath.length != 0) {
        for (var i = 0; i < includePath.length; i++) {
            listWidget.appendItem(includePath[i]);
        }
    }
    
    // Fill in the module dir with a reasonable value if possible.
    if (parent.wd_moduleDir) {
        _UpdateModuleDir(parent.wd_moduleDir);
    }
    
    parent.wizardManager.onPageLoad(_gPanelName);
}


function UpdateModuleDir_OnSelection()
{
    // User selected one of the exist include_path dirs.
    // Load the default installation textfield with the selection
    var listbox = document.getElementById("include-path-list");
    _UpdateModuleDir(listbox.selectedItem.getAttribute('label'));
}


function UpdateModuleDir_OnKey()
{
    // User typed into the installation field.
    // - Unselect any tree item.
    var listbox = document.getElementById("include-path-list");
    listbox.selectedIndex = -1;
    
    // - Persist the value.
    var moduleDirWidget = document.getElementById("module-dir");
    _UpdateModuleDir(moduleDirWidget.value);
}


function UpdateModuleDir_OnBrowse()
{
    var moduleDir = filepicker_getFolder();
    if (moduleDir != null) {
        _UpdateModuleDir(moduleDir);
    }
}

